<?php
/**
* @package      EasySocial
* @copyright    Copyright (C) 2010 - 2017 Stack Ideas Sdn Bhd. All rights reserved.
* @license      GNU/GPL, see LICENSE.php
* EasySocial is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/
defined('_JEXEC') or die('Unauthorized Access');

ES::import('admin:/includes/fields/dependencies');

class SocialFieldsUserInvitation_code extends SocialFieldItem
{
	/**
	 * Retrieve the stored codes
	 *
	 * @since	2.1
	 * @access	public
	 */
	public function retrieveCodes()
	{
		return $this->ajax->resolve();
	}

	/**
	 * Allows caller to generate new codes
	 *
	 * @since	2.1
	 * @access	public
	 */
	public function generateCodes()
	{
		$currentCodes = $this->input->get('storedValue', '', 'raw');
		$codesArray = array();

		if ($currentCodes) {
			$codesArray = explode("\n", $currentCodes);
		}

		// 20 codes per operation
		$limit = 20;
		$total = 0;

		do {
			$code = uniqid();
			$code = md5($code);

			// Check for duplication
			if (in_array($code, $codesArray)) {
				continue;
			}

			$codesArray[] = $code;
			$total++;
		} while ($total < $limit);

		$codes = implode("\n", $codesArray);

		return $this->ajax->resolve($codes);
	}

	/**
	 * Determine if the code is valid for use
	 *
	 * @since	4.0.0
	 * @access	public
	 */
	public function isValid()
	{
		$code = $this->input->get('code', '', 'string');

		$availableCodes = $this->params->get('code_listing');
		$availableCodes = explode("\n", $availableCodes);

		if (!in_array($code, $availableCodes)) {
			return $this->ajax->reject(JText::_('PLG_FIELDS_INVITATION_CODE_VALIDATION_INPUT_INVALID'));
		}

		$text = JText::_('PLG_FIELDS_INVITATION_CODE_AVAILABLE');

		return $this->ajax->resolve($text);
	}
}
